From f56163575eb0f4536e9dba7469299d8cd373d43c Mon Sep 17 00:00:00 2001
From: Arun Raghavan <arunsr@codeaurora.org>
Date: Mon, 28 May 2018 21:54:38 +0530
Subject: [PATCH 4/4] WIP pulsesrc: Add support for IEC61937 capture

---
 ext/pulse/pulsesrc.c  |  6 +++++-
 ext/pulse/pulseutil.c | 38 ++++++++++++++++++++++++++++++++++++++
 ext/pulse/pulseutil.h |  1 +
 3 files changed, 44 insertions(+), 1 deletion(-)

diff --git a/ext/pulse/pulsesrc.c b/ext/pulse/pulsesrc.c
index 93dc34c6e..76d5cc20c 100644
--- a/ext/pulse/pulsesrc.c
+++ b/ext/pulse/pulsesrc.c
@@ -218,7 +218,11 @@ gst_pulsesrc_class_init (GstPulseSrcClass * klass)
       "Source/Audio",
       "Captures audio from a PulseAudio server", "Lennart Poettering");
 
-  caps = gst_pulse_fix_pcm_caps (gst_caps_from_string (_PULSE_CAPS_PCM));
+  caps = gst_pulse_fix_pcm_caps (gst_caps_from_string (_PULSE_CAPS_PCM
+#if PA_CHECK_VERSION(11,0,0)
+          _PULSE_CAPS_UNKNOWN_IEC61937
+#endif
+      ));
   gst_element_class_add_pad_template (gstelement_class,
       gst_pad_template_new ("src", GST_PAD_SRC, GST_PAD_ALWAYS, caps));
   gst_caps_unref (caps);
diff --git a/ext/pulse/pulseutil.c b/ext/pulse/pulseutil.c
index c3bd3f110..ac1307f07 100644
--- a/ext/pulse/pulseutil.c
+++ b/ext/pulse/pulseutil.c
@@ -170,6 +170,26 @@ gst_pulse_fill_format_info (GstAudioRingBufferSpec * spec, pa_format_info ** f,
   } else if (spec->type == GST_AUDIO_RING_BUFFER_FORMAT_TYPE_MPEG4_AAC) {
     /* HACK. treat MPEG4 AAC as MPEG2 AAC for the moment */
     format->encoding = PA_ENCODING_MPEG2_AAC_IEC61937;
+#endif
+/* FIXME: THIS IS NOT THE CORRECT VERSION UPSTREAM */
+#if PA_CHECK_VERSION(11,0,0)
+  } else if (spec->type == GST_AUDIO_RING_BUFFER_FORMAT_TYPE_IEC61937) {
+    GstStructure *st = gst_caps_get_structure (spec->caps, 0);
+    const char *payload_type;
+
+    if (gst_structure_has_field (st, "payload-type"))
+      payload_type = gst_structure_get_string (st, "payload-type");
+    else
+      payload_type = "normal";
+
+    if (g_str_equal (payload_type, "normal"))
+      format->encoding = PA_ENCODING_UNKNOWN_IEC61937;
+    else if (g_str_equal (payload_type, "4x"))
+      format->encoding = PA_ENCODING_UNKNOWN_4X_IEC61937;
+    else if (g_str_equal (payload_type, "hbr"))
+      format->encoding = PA_ENCODING_UNKNOWN_HBR_IEC61937;
+    else
+      g_assert_not_reached ();
 #endif
   } else {
     goto fail;
@@ -515,6 +535,24 @@ gst_pulse_format_info_to_caps (pa_format_info * format)
       ret = gst_caps_from_string (_PULSE_CAPS_MP3);
       break;
 
+/* FIXME: THIS IS NOT THE CORRECT VERSION UPSTREAM */
+#if PA_CHECK_VERSION(11,0,0)
+    case PA_ENCODING_UNKNOWN_IEC61937:
+      ret = gst_caps_from_string (_PULSE_CAPS_UNKNOWN_IEC61937);
+      gst_caps_set_simple (ret, "payload-type", G_TYPE_STRING, "normal", NULL);
+      break;
+
+    case PA_ENCODING_UNKNOWN_4X_IEC61937:
+      ret = gst_caps_from_string (_PULSE_CAPS_UNKNOWN_IEC61937);
+      gst_caps_set_simple (ret, "payload-type", G_TYPE_STRING, "4x", NULL);
+      break;
+
+    case PA_ENCODING_UNKNOWN_HBR_IEC61937:
+      ret = gst_caps_from_string (_PULSE_CAPS_UNKNOWN_IEC61937);
+      gst_caps_set_simple (ret, "payload-type", G_TYPE_STRING, "hbr", NULL);
+      break;
+#endif
+
     default:
       GST_WARNING ("Found a PA format that we don't support yet");
       goto out;
diff --git a/ext/pulse/pulseutil.h b/ext/pulse/pulseutil.h
index b95c1cbee..754728db1 100644
--- a/ext/pulse/pulseutil.h
+++ b/ext/pulse/pulseutil.h
@@ -65,6 +65,7 @@
     "mpegaudioversion = (int) [ 1, 2 ], parsed = (boolean) true;"
 #define _PULSE_CAPS_AAC "audio/mpeg, mpegversion = (int) { 2, 4 }, " \
     "framed = (boolean) true, stream-format = (string) adts;"
+#define _PULSE_CAPS_UNKNOWN_IEC61937 "audio/x-iec61937"
 
 #define _PULSE_CAPS_PCM \
   _PULSE_CAPS_LINEAR \
-- 
2.19.1

